chiark / gitweb /
572aa755b1e9dc254710f6c2534c3a30402c9129
[profile] / bin / mdw-build
1 #! /bin/bash
2 ###
3 ### Build script for Debian packages
4 ###
5 ### (c) 2008 Mark Wooding
6 ###
7
8 ###----- Licensing notice ---------------------------------------------------
9 ###
10 ### This program is free software; you can redistribute it and/or modify
11 ### it under the terms of the GNU General Public License as published by
12 ### the Free Software Foundation; either version 2 of the License, or
13 ### (at your option) any later version.
14 ###
15 ### This program is distributed in the hope that it will be useful,
16 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
18 ### GNU General Public License for more details.
19 ###
20 ### You should have received a copy of the GNU General Public License
21 ### along with this program; if not, write to the Free Software Foundation,
22 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
23
24 ###--------------------------------------------------------------------------
25 ### Conventions for build systems.
26 ###
27 ### This script is designed to work with a variety of `make'-based build
28 ### systems, but there are a number of conventions which must be followed if
29 ### this is going to work properly.
30 ###
31 ###   * There must be a `configure.ac', `configure.in', or `.links' file, or
32 ###     a `.git' directory in the project top-level, so that we can find it.
33 ###
34 ###   * The following `make' variables must be assigned in the top-level
35 ###     Makefile, after `mdw-build' has constructed it.
36 ###
37 ###     distdir         The name of the top-level project directory in the
38 ###                     source distribution, and the base name for
39 ###                     distribution archives; should be of the form
40 ###                     `PROJECT-VERSION'.
41 ###
42 ###     The following `make' targets must be available in the top-level
43 ###     Makefile.
44 ###
45 ###     dist            Write to $(distdir).tar.gz a source distribution of
46 ###                     the package.
47 ###
48 ###     distcheck       As for `dist', but also build and test the project.
49 ###
50 ###  * The source distribution constructed by `make dist' must contain a file
51 ###     $(distdir)/RELEASE containing the release name.  This isn't currently
52 ###     tested, but it might be later.
53
54 set -e
55
56 ###--------------------------------------------------------------------------
57 ### Configuration.
58
59 unset checkout checkoutrev
60 unset setup setupcmd
61 unset sign signkey
62 unset upload uploadpath
63 unset dput dputtarget
64 unset build distcheck debian clean vpath native
65 for i in \
66   "/etc/mdw-build.conf" \
67   "${XDG_CONFIG_HOME-$HOME/.config}/mdw-build.conf" \
68   "./.mdw-build.conf"
69 do
70   if [ -f "$i" ]; then . "$i"; fi
71 done
72 default_depends () {
73   var=$1 want=$2
74   eval "p=\${$var+t} q=\${$want+t}"
75   case $p,$q in t,*) ;; *,t) eval "$var=yes" ;; *) eval "$var=no" ;; esac
76 }
77 : ${checkout=yes} ${checkoutrev=HEAD}
78 : ${build=test}
79 : ${setup=yes} ${setupcmd=mdw-setup}
80 : ${distcheck=yes}
81 : ${debian=yes}
82 : ${clean=yes}
83 : ${vpath=yes}
84 : ${native=yes}
85 default_depends sign signkey
86 default_depends upload uploadpath
87 default_depends dput dputtarget
88 : ${DEB_BUILD_OPTIONS=parallel=4}; export DEB_BUILD_OPTIONS
89
90 ###--------------------------------------------------------------------------
91 ### Parse options.
92
93 prog=${0##*/}
94
95 usage () {
96   cat <<EOF
97 Usage: $prog [-vr] BUILDOPT
98
99 Build options:
100
101   [no]checkout[=REV]
102   [no]release
103   [no]setup[=RUNE]
104   [no]distcheck
105   [no]debian
106   [no]upload[=SERVER:PATH]
107   [no]dput[=TARGET]
108   [no]clean
109   [no]vpath
110   [no]sign[=KEYID]
111   [no]native
112 EOF
113 }
114
115 ## Parse simple options.
116 verbose=no
117 while getopts "hvr" opt; do
118   case "$opt" in
119     h) usage; exit 0 ;;
120     v) verbose=yes ;;
121     *) exit 1 ;;
122   esac
123 done
124 shift $((OPTIND - 1))
125
126 ## Parse the build options.
127 maybe_set () {
128   var=$1 want=$2
129   eval "p=\${$want+t}\${$want-nil}"
130   case $p in
131     t) eval $var=yes ;;
132     nil) echo >&2 "$prog: $want not set"; exit 1 ;;
133   esac
134 }
135 for opt; do
136   case "$opt" in
137     checkout)   checkout=yes checkoutrev=HEAD ;;
138     checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
139     release)    build=release ;;
140     norelease)  build=test ;;
141     setup)      setup=yes setupcmd=mdw-setup ;;
142     setup=*)    setup=yes setupcmd=${opt#*=} ;;
143     upload)     maybe_set upload uploadpath ;;
144     upload=*)   upload=yes uploadpath=${opt#*=} ;;
145     sign)       maybe_set sign signkey ;;
146     sign=*)     sign=yes signkey=${opt#*=} ;;
147     dput)       maybe_set dput dputtarget ;;
148     dput=*)     dput=yes dputtarget=${opt#*=} ;;
149
150     distcheck | debian | clean | vpath | native)
151       eval "$opt=yes"
152       ;;
153     nocheckout | nosetup | nodistcheck | nodebian | \
154     noupload | nodput | noclean | novpath | nonative | nosign)
155       eval "${opt#no}=no"
156       ;;
157     *)
158       usage >&2
159       exit 1
160       ;;
161   esac
162 done
163
164 ## Parse DEB_BUILD_OPTIONS.
165 jobs=1
166 set -- $DEB_BUILD_OPTIONS
167 for opt; do
168   case "$opt" in
169     parallel=*) jobs=${opt#*=} ;;
170   esac
171 done
172
173 makeopts=""
174 case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
175
176 ###--------------------------------------------------------------------------
177 ### Utility functions.
178
179 exec 3>&2 4>/dev/null 5>&2
180
181 notify () {
182   colour=$1 message=$2
183   echo $message >&4
184   echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&5
185 }
186
187 fail () {
188   notify 1 "!!! $*"
189   exit 1
190 }
191
192 warn () {
193   case $build in
194     release) fail "$*" ;;
195     *) notify 5 "??? $*" ;;
196   esac
197 }
198
199 info () {
200   notify 6 "--- $*"
201 }
202
203 assign () {
204   info "$1 = $2"
205   eval "$1=$2"
206 }
207
208 runx () {
209   notify 2 "+++ $*"
210   "$@" 2>&3 || fail "$1: exit $?"
211 }
212
213 run () { runx "$@" >&3; }
214
215 yesno () {
216   echo -n "(test $*)" >&4
217   if "$@" >&4 2>&4; then
218     echo "(yes)" >&4
219     echo yes
220   else
221     echo "(no)" >&4
222     echo no
223   fi
224 }
225
226 ###--------------------------------------------------------------------------
227 ### Do the building.
228
229 ## Find the top-level package directory.
230 while [ ! -f configure.ac -a ! -f configure.in -a \
231         ! -f .links -a ! -d .git ]; do
232   case "$(pwd)" in
233     /)
234       fail "couldn't find top-level directory"
235       ;;
236   esac
237   cd ..
238 done
239 assign srcpath $(pwd)
240
241 ## Build any necessary qualifiers.
242 qual= sep=.
243 case ${SBOX_SESSION_DIR+t},${DEB_BUILD_ARCH+t} in
244   t,t) qual=$qual$sep$DEB_BUILD_ARCH; sep=- ;;
245   t,*) fail "unknown build arch" ;;
246 esac
247
248 ## Construct the output directory.
249 assign releasepath $srcpath/dist-$build$qual
250 chmod -R +w $releasepath 2>/dev/null || :
251 rm -rf $releasepath 2>/dev/null || :
252 mkdir $releasepath
253 case $verbose in
254   no)
255     exec 4>$releasepath/mdw-build.log 3>&4 ||
256       fail "Failed to create log."
257     ;;
258 esac
259
260 ## Do we have a Git repository?
261 case "$checkout,$setup,$(yesno [ -d $srcpath/.git ])" in
262   yes,no,*)
263     fail "Inconsistent options: can't check out without setup."
264     ;;
265   yes,yes,no)
266     info "No Git repository found."
267     checkout=no gitver=none
268     ;;
269   yes,yes,yes)
270     cd $srcpath
271     [ "$(git ls-files -m)" = "" ] ||
272       warn "working tree has uncommitted changes"
273     ;;
274 esac
275
276 ## Is there Debian build equipment?
277 case "$debian,$(yesno [ -d $srcpath/debian ])" in
278   yes,no)
279     info "No debian directory found."
280     debian=no debver=none
281     ;;
282   no,*)
283     debver=none
284     ;;
285   yes,yes)
286     debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p' | tr \~ -)
287     debsrc=$(dpkg-parsechangelog | sed -n 's/^Source: //p')
288     debname=$(git config user.name) debemail=$(git config user.email)
289     ;;
290 esac
291
292 ## Maybe check out a copy of the source.
293 case "$checkout" in
294   yes)
295     cd $releasepath
296     run git clone -sn $srcpath/.git _source
297     assign srcpath $releasepath/_source
298     cd $srcpath
299     run git checkout -b mdw-build $checkoutrev
300     gitver=$(git describe --abbrev=4)
301     ;;
302 esac
303
304 ## Check the version number.
305 hack_dch_p=no
306 case "$gitver,$debver" in
307   none,* | *,none)
308     ;;
309   *)
310     if [ "$gitver" != "$debver" ]; then
311       warn "Git version $gitver doesn't match Debian version $debver"
312       hack_dch=yes
313     fi
314     ;;
315 esac
316
317 ## Maybe refresh the build machinery.
318 case "$setup" in
319   yes)
320     run $setupcmd
321     ;;
322 esac
323
324 ## Initialize the build directory.
325 case "$vpath,$(yesno [ -e $srcpath/configure ])" in
326   yes,yes)
327     assign buildpath $releasepath/_build
328     mkdir $buildpath
329     cd $buildpath
330     run $srcpath/configure
331     ;;
332   no,yes)
333     info "VPATH build disabled"
334     assign buildpath $srcpath
335     distcheck=no
336     cd $srcpath
337     run ./configure
338     ;;
339   *,no)
340     info "no configure script"
341     assign buildpath $srcpath
342     cd $srcpath
343     ;;
344 esac
345
346 ## Discover the release name.
347 cat >find-distdir.mk <<'EOF'
348 include Makefile
349 print-distdir:
350         @echo >&3 $(distdir)
351 EOF
352 assign distdir \
353         $({ make -f find-distdir.mk print-distdir >/dev/null 2>&1; } 3>&1)
354
355 ## Get a tarball distribution.
356 case "$distcheck" in
357   yes)
358     run make $makeopts distcheck
359     ;;
360   no)
361     run make $makeopts dist
362     ;;
363 esac
364
365 cd $releasepath
366
367 case $native in
368   yes)
369     if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE
370     then
371       fail "missing RELEASE file in distribution"
372     fi
373     ;;
374 esac
375
376 run mv $buildpath/$distdir.tar.gz .
377 case $build,$sign in
378   release,yes)
379     run gpg -u$signkey -ab -o$distdir.tar.gz.gpg $distdir.tar.gz
380     ;;
381 esac
382
383 ## Maybe build the Debian packages.
384 case "$debian" in
385   yes)
386     run tar xvfz $distdir.tar.gz
387     cd $distdir
388     case $hack_dch in
389       yes)
390         dver=$(echo $gitver | sed 's/-/+/; s/-/./g')
391         now=$(date -R)
392         cat - debian/changelog >debian/changelog.new <<EOF
393 $debsrc ($dver) experimental; urgency=low
394
395   * Hacking in process, not intended for release.
396
397  -- $debname <$debemail>  $now
398
399 EOF
400         mv debian/changelog.new debian/changelog
401         ;;
402     esac
403     case $build,$sign in
404       release,yes) run dpkg-buildpackage -k$signkey ;;
405       no,*) run dpkg-buildpackage -us -uc ;;
406     esac
407     ;;
408 esac
409
410 ## Maybe upload Debian packages.
411 cd $releasepath
412 case "$upload,$build" in
413   yes,test) info "Test build: not uploading." ;;
414   yes,release) run rsync $distdir.tar.gz $distdir.tar.gz.gpg $uploadpath ;;
415 esac
416 case "$debian,$upload,$dput,$build" in
417   yes,yes,yes,release) run dput -f $dputtarget *.changes ;;
418 esac
419
420 ## Tidy up.
421 case "$clean" in
422   yes)
423     rm -rf $releasepath/$distdir
424     rm -rf $releasepath/_source
425     rm -rf $releasepath/_build
426     ;;
427 esac
428
429 ## Done.
430 info "All OK."
431
432 ###----- That's all, folks --------------------------------------------------